diff -cprN head/doc/src/sgml/catalogs.sgml work/doc/src/sgml/catalogs.sgml
*** head/doc/src/sgml/catalogs.sgml	2010-01-18 09:26:23.915594000 +0900
--- work/doc/src/sgml/catalogs.sgml	2010-01-18 14:38:33.968374454 +0900
***************
*** 194,199 ****
--- 194,204 ----
       </row>
  
       <row>
+       <entry><link linkend="catalog-pg-partition"><structname>pg_partition</structname></link></entry>
+       <entry>key definitions for partitioned tables</entry>
+      </row>
+ 
+      <row>
        <entry><link linkend="catalog-pg-pltemplate"><structname>pg_pltemplate</structname></link></entry>
        <entry>template data for procedural languages</entry>
       </row>
***************
*** 2996,3001 ****
--- 3001,3017 ----
         inherited columns are to be arranged.  The count starts at 1
        </entry>
       </row>
+ 
+      <row>
+       <entry><structfield>inhvalues</structfield></entry>
+       <entry><type>anyarray</type></entry>
+       <entry></entry>
+       <entry>
+        An array of partition values.
+        An empty array for overflow partitions.
+        NULL for non-partitioned tables.
+       </entry>
+      </row>
      </tbody>
     </tgroup>
    </table>
***************
*** 3705,3710 ****
--- 3721,3787 ----
   </sect1>
  
  
+  <sect1 id="catalog-pg-partition">
+   <title><structname>pg_partition</structname></title>
+ 
+   <indexterm zone="catalog-pg-partition">
+    <primary>pg_partition</primary>
+   </indexterm>
+ 
+   <para>
+    The catalog <structname>pg_partition</structname> stores
+    <quote>key definitions</> for partitioned tables.
+   </para>
+ 
+   <table>
+    <title><structname>pg_partition</> Columns</title>
+ 
+    <tgroup cols="4">
+     <thead>
+      <row>
+       <entry>Name</entry>
+       <entry>Type</entry>
+       <entry>References</entry>
+       <entry>Description</entry>
+      </row>
+     </thead>
+ 
+     <tbody>
+      <row>
+       <entry><structfield>partrelid</structfield></entry>
+       <entry><type>oid</type></entry>
+       <entry>pg_class.oid</entry>
+       <entry>Partitioned table oid</entry>
+      </row>
+ 
+      <row>
+       <entry><structfield>partopclass</structfield></entry>
+       <entry><type>oid</type></entry>
+       <entry>pg_opclass.oid</entry>
+       <entry>Operator class to compare keys</entry>
+      </row>
+ 
+      <row>
+       <entry><structfield>partkind</structfield></entry>
+       <entry><type>char</type></entry>
+       <entry></entry>
+       <entry>Kind of partition: RANGE or LIST</entry>
+      </row>
+ 
+      <row>
+       <entry><structfield>partkey</structfield></entry>
+       <entry><type>text</type></entry>
+       <entry></entry>
+       <entry>Partition key expression</entry>
+      </row>
+ 
+     </tbody>
+    </tgroup>
+   </table>
+ 
+  </sect1>
+ 
+ 
   <sect1 id="catalog-pg-pltemplate">
    <title><structname>pg_pltemplate</structname></title>
  
diff -cprN head/doc/src/sgml/ddl.sgml work/doc/src/sgml/ddl.sgml
*** head/doc/src/sgml/ddl.sgml	2009-10-26 09:29:38.916447000 +0900
--- work/doc/src/sgml/ddl.sgml	2010-01-18 17:41:52.684540000 +0900
*************** VALUES ('New York', NULL, NULL, 'NY');
*** 2310,2315 ****
--- 2310,2321 ----
          example one might partition by date ranges, or by ranges of
          identifiers for particular business objects.
         </para>
+        <para>
+         The syntax for range partitioning is:
+ <programlisting>
+ PARTITION BY RANGE ( partitioning_key )
+ </programlisting>
+        </para>
        </listitem>
       </varlistentry>
  
*************** VALUES ('New York', NULL, NULL, 'NY');
*** 2321,2326 ****
--- 2327,2338 ----
          The table is partitioned by explicitly listing which key values
          appear in each partition.
         </para>
+        <para>
+         The syntax for list partitioning is:
+ <programlisting>
+ PARTITION BY LIST ( partitioning_key )
+ </programlisting>
+        </para>
        </listitem>
       </varlistentry>
      </variablelist>
*************** VALUES ('New York', NULL, NULL, 'NY');
*** 2341,2404 ****
         <para>
          This table will contain no data.  Do not define any check
          constraints on this table, unless you intend them to
!         be applied equally to all partitions.  There is no point
!         in defining any indexes or unique constraints on it, either.
         </para>
-       </listitem>
- 
-       <listitem>
         <para>
!         Create several <quote>child</quote> tables that each inherit from
!         the master table.  Normally, these tables will not add any columns
!         to the set inherited from the master.
         </para>
  
         <para>
!         We will refer to the child tables as partitions, though they
!         are in every way normal <productname>PostgreSQL</> tables.
         </para>
        </listitem>
  
        <listitem>
         <para>
!         Add table constraints to the partition tables to define the
!         allowed key values in each partition.
         </para>
  
         <para>
          Typical examples would be:
  <programlisting>
! CHECK ( x = 1 )
! CHECK ( county IN ( 'Oxfordshire', 'Buckinghamshire', 'Warwickshire' ))
! CHECK ( outletID &gt;= 100 AND outletID &lt; 200 )
  </programlisting>
          Ensure that the constraints guarantee that there is no overlap
!         between the key values permitted in different partitions.  A common
!         mistake is to set up range constraints like:
! <programlisting>
! CHECK ( outletID BETWEEN 100 AND 200 )
! CHECK ( outletID BETWEEN 200 AND 300 )
! </programlisting>
!         This is wrong since it is not clear which partition the key value
!         200 belongs in.
         </para>
  
         <para>
!         Note that there is no difference in
!         syntax between range and list partitioning; those terms are
!         descriptive only.
         </para>
-       </listitem>
  
-       <listitem>
-        <para>
-         For each partition, create an index on the key column(s),
-         as well as any other indexes you might want.  (The key index is
-         not strictly necessary, but in most scenarios it is helpful.
-         If you intend the key values to be unique then you should
-         always create a unique or primary-key constraint for each
-         partition.)
-        </para>
        </listitem>
  
        <listitem>
--- 2353,2402 ----
         <para>
          This table will contain no data.  Do not define any check
          constraints on this table, unless you intend them to
!         be applied equally to all partitions.
         </para>
         <para>
!         Typical examples would be:
! <programlisting>
! CREATE TABLE address (...) PARTITION BY LIST ( county );
! CREATE TABLE outlet (...) PARTITION BY RANGE ( outletID );
! </programlisting>
         </para>
+       </listitem>
  
+       <listitem>
         <para>
!         Create an index on the key column(s) on the master table,
!         as well as any other indexes you might want.  (The key index is
!         not strictly necessary, but in most scenarios it is helpful.
!         If you intend the key values to be unique then you should
!         always create a unique or primary-key constraint on it.)
         </para>
        </listitem>
  
        <listitem>
         <para>
!         Create several <quote>child</quote> tables that each inherit from
!         the master table with table constraints to define the allowed key
!         values in each partition.  Normally, these tables will not add any
!         columns to the set inherited from the master.
         </para>
  
         <para>
          Typical examples would be:
  <programlisting>
! CREATE PARTITION address_ON address VALUES IN ( 'Oxfordshire', 'Buckinghamshire', 'Warwickshire' );
! CREATE PARTITION outlet_100 ON outlet VALUES LESS THAN 200;
  </programlisting>
          Ensure that the constraints guarantee that there is no overlap
!         between the key values permitted in different partitions.
         </para>
  
         <para>
!         We will refer to the child tables as partitions, though they
!         are in every way normal <productname>PostgreSQL</> tables.
         </para>
  
        </listitem>
  
        <listitem>
*************** CREATE TABLE measurement (
*** 2460,2479 ****
  
        <listitem>
         <para>
          Next we create one partition for each active month:
  
  <programlisting>
! CREATE TABLE measurement_y2006m02 ( ) INHERITS (measurement);
! CREATE TABLE measurement_y2006m03 ( ) INHERITS (measurement);
  ...
! CREATE TABLE measurement_y2007m11 ( ) INHERITS (measurement);
! CREATE TABLE measurement_y2007m12 ( ) INHERITS (measurement);
! CREATE TABLE measurement_y2008m01 ( ) INHERITS (measurement);
  </programlisting>
  
          Each of the partitions are complete tables in their own right,
          but they inherit their definitions from the
!         <structname>measurement</> table.
         </para>
  
         <para>
--- 2458,2490 ----
  
        <listitem>
         <para>
+         Define a partition key to the master table and create an index on
+         the key column. If you need further indexes for each partition,
+         add them at this time.
+ <programlisting>
+ ALTER TABLE measurement PARTITION BY RANGE (logdate);
+ CREATE INDEX measurement_logdate ON measurement (logdate);
+ </programlisting>
+        </para>
+       </listitem>
+ 
+       <listitem>
+        <para>
          Next we create one partition for each active month:
  
  <programlisting>
! CREATE PARTITION measurement_y2006m02 ON measurement VALUES LESS THAN '2006-03-01';
! CREATE PARTITION measurement_y2006m03 ON measurement VALUES LESS THAN '2006-04-01';
  ...
! CREATE PARTITION measurement_y2007m11 ON measurement VALUES LESS THAN '2007-12-01';
! CREATE PARTITION measurement_y2007m12 ON measurement VALUES LESS THAN '2008-01-01';
! CREATE PARTITION measurement_y2008m01 ON measurement VALUES LESS THAN '2008-02-01';
  </programlisting>
  
          Each of the partitions are complete tables in their own right,
          but they inherit their definitions from the
!         <structname>measurement</> table including indexes.
!         They also have non-overlapping table constraints.
         </para>
  
         <para>
*************** CREATE TABLE measurement_y2008m01 ( ) IN
*** 2486,2535 ****
  
        <listitem>
         <para>
-         We must provide non-overlapping table constraints.  Rather than
-         just creating the partition tables as above, the table creation
-         script should really be:
- 
-  <programlisting>
- CREATE TABLE measurement_y2006m02 (
-     CHECK ( logdate &gt;= DATE '2006-02-01' AND logdate &lt; DATE '2006-03-01' )
- ) INHERITS (measurement);
- CREATE TABLE measurement_y2006m03 (
-     CHECK ( logdate &gt;= DATE '2006-03-01' AND logdate &lt; DATE '2006-04-01' )
- ) INHERITS (measurement);
- ...
- CREATE TABLE measurement_y2007m11 (
-     CHECK ( logdate &gt;= DATE '2007-11-01' AND logdate &lt; DATE '2007-12-01' )
- ) INHERITS (measurement);
- CREATE TABLE measurement_y2007m12 (
-     CHECK ( logdate &gt;= DATE '2007-12-01' AND logdate &lt; DATE '2008-01-01' )
- ) INHERITS (measurement);
- CREATE TABLE measurement_y2008m01 (
-     CHECK ( logdate &gt;= DATE '2008-01-01' AND logdate &lt; DATE '2008-02-01' )
- ) INHERITS (measurement);
- </programlisting>
-        </para>
-       </listitem>
- 
-       <listitem>
-        <para>
-         We probably need indexes on the key columns too:
- 
-  <programlisting>
- CREATE INDEX measurement_y2006m02_logdate ON measurement_y2006m02 (logdate);
- CREATE INDEX measurement_y2006m03_logdate ON measurement_y2006m03 (logdate);
- ...
- CREATE INDEX measurement_y2007m11_logdate ON measurement_y2007m11 (logdate);
- CREATE INDEX measurement_y2007m12_logdate ON measurement_y2007m12 (logdate);
- CREATE INDEX measurement_y2008m01_logdate ON measurement_y2008m01 (logdate);
- </programlisting>
- 
-         We choose not to add further indexes at this time.
-        </para>
-       </listitem>
- 
-       <listitem>
-        <para>
          We want our application to be able to say <literal>INSERT INTO
          measurement ...</> and have the data be redirected into the
          appropriate partition table.  We can arrange that by attaching
--- 2497,2502 ----
*************** CREATE TRIGGER insert_measurement_trigge
*** 2571,2589 ****
  CREATE OR REPLACE FUNCTION measurement_insert_trigger()
  RETURNS TRIGGER AS $$
  BEGIN
!     IF ( NEW.logdate &gt;= DATE '2006-02-01' AND
!          NEW.logdate &lt; DATE '2006-03-01' ) THEN
!         INSERT INTO measurement_y2006m02 VALUES (NEW.*);
!     ELSIF ( NEW.logdate &gt;= DATE '2006-03-01' AND
!             NEW.logdate &lt; DATE '2006-04-01' ) THEN
!         INSERT INTO measurement_y2006m03 VALUES (NEW.*);
!     ...
!     ELSIF ( NEW.logdate &gt;= DATE '2008-01-01' AND
!             NEW.logdate &lt; DATE '2008-02-01' ) THEN
!         INSERT INTO measurement_y2008m01 VALUES (NEW.*);
!     ELSE
!         RAISE EXCEPTION 'Date out of range.  Fix the measurement_insert_trigger() function!';
!     END IF;
      RETURN NULL;
  END;
  $$
--- 2538,2546 ----
  CREATE OR REPLACE FUNCTION measurement_insert_trigger()
  RETURNS TRIGGER AS $$
  BEGIN
!     EXECUTE 'INSERT INTO '
!             || quote_ident(to_char(NEW.logdate, '"measurement_y"yyyy"m"mm'))
!             || ' VALUES ($1.*)' USING NEW;
      RETURN NULL;
  END;
  $$
*************** LANGUAGE plpgsql;
*** 2591,2625 ****
  </programlisting>
  
          The trigger definition is the same as before.
!         Note that each <literal>IF</literal> test must exactly match the
!         <literal>CHECK</literal> constraint for its partition.
         </para>
  
         <para>
          While this function is more complex than the single-month case,
!         it doesn't need to be updated as often, since branches can be
!         added in advance of being needed.
         </para>
- 
-        <note>
-         <para>
-          In practice it might be best to check the newest partition first,
-          if most inserts go into that partition.  For simplicity we have
-          shown the trigger's tests in the same order as in other parts
-          of this example.
-         </para>
-        </note>
        </listitem>
       </orderedlist>
      </para>
  
-     <para>
-      As we can see, a complex partitioning scheme could require a
-      substantial amount of DDL. In the above example we would be
-      creating a new partition each month, so it might be wise to write a
-      script that generates the required DDL automatically.
-     </para>
- 
     </sect2>
  
     <sect2 id="ddl-partitioning-managing-partitions">
--- 2548,2566 ----
  </programlisting>
  
          The trigger definition is the same as before.
!         Note that names generated by <literal>to_char</literal> must exactly
!         match the partition names.
         </para>
  
         <para>
          While this function is more complex than the single-month case,
!         it doesn't need to be updated as long as we continue to use the
!         same rule for partition names.
         </para>
        </listitem>
       </orderedlist>
      </para>
  
     </sect2>
  
     <sect2 id="ddl-partitioning-managing-partitions">
*************** DROP TABLE measurement_y2006m02;
*** 2651,2657 ****
       the partitioned table but retain access to it as a table in its own
       right:
  <programlisting>
! ALTER TABLE measurement_y2006m02 NO INHERIT measurement;
  </programlisting>
       This allows further operations to be performed on the data before
       it is dropped. For example, this is often a useful time to back up
--- 2592,2598 ----
       the partitioned table but retain access to it as a table in its own
       right:
  <programlisting>
! ALTER TABLE measurement DETACH PARTITION measurement_y2006m02;
  </programlisting>
       This allows further operations to be performed on the data before
       it is dropped. For example, this is often a useful time to back up
*************** ALTER TABLE measurement_y2006m02 NO INHE
*** 2667,2675 ****
       were created above:
  
  <programlisting>
! CREATE TABLE measurement_y2008m02 (
!     CHECK ( logdate &gt;= DATE '2008-02-01' AND logdate &lt; DATE '2008-03-01' )
! ) INHERITS (measurement);
  </programlisting>
  
       As an alternative, it is sometimes more convenient to create the
--- 2608,2614 ----
       were created above:
  
  <programlisting>
! CREATE PARTITION measurement_y2008m02 ON measurement VALUES LESS THAN '2008-03-01';
  </programlisting>
  
       As an alternative, it is sometimes more convenient to create the
*************** CREATE TABLE measurement_y2008m02 (
*** 2678,2690 ****
       transformed prior to it appearing in the partitioned table:
  
  <programlisting>
! CREATE TABLE measurement_y2008m02
!   (LIKE measurement INCLUDING DEFAULTS INCLUDING CONSTRAINTS);
! ALTER TABLE measurement_y2008m02 ADD CONSTRAINT y2008m02
!    CHECK ( logdate &gt;= DATE '2008-02-01' AND logdate &lt; DATE '2008-03-01' );
  \copy measurement_y2008m02 from 'measurement_y2008m02'
  -- possibly some other data preparation work
! ALTER TABLE measurement_y2008m02 INHERIT measurement;
  </programlisting>
      </para>
     </sect2>
--- 2617,2626 ----
       transformed prior to it appearing in the partitioned table:
  
  <programlisting>
! CREATE TABLE measurement_y2008m02 (LIKE measurement INCLUDING ALL);
  \copy measurement_y2008m02 from 'measurement_y2008m02'
  -- possibly some other data preparation work
! ALTER TABLE measurement ATTACH PARTITION measurement_y2008m02 VALUES LESS THAN '2008-03-01';
  </programlisting>
      </para>
     </sect2>
diff -cprN head/doc/src/sgml/ref/allfiles.sgml work/doc/src/sgml/ref/allfiles.sgml
*** head/doc/src/sgml/ref/allfiles.sgml	2009-12-11 12:39:49.829461000 +0900
--- work/doc/src/sgml/ref/allfiles.sgml	2010-01-18 14:38:33.969376893 +0900
*************** Complete list of usable sgml source file
*** 58,63 ****
--- 58,64 ----
  <!entity createOperator     system "create_operator.sgml">
  <!entity createOperatorClass system "create_opclass.sgml">
  <!entity createOperatorFamily system "create_opfamily.sgml">
+ <!entity createPartition    system "create_partition.sgml">
  <!entity createRole         system "create_role.sgml">
  <!entity createRule         system "create_rule.sgml">
  <!entity createSchema       system "create_schema.sgml">
diff -cprN head/doc/src/sgml/ref/alter_table.sgml work/doc/src/sgml/ref/alter_table.sgml
*** head/doc/src/sgml/ref/alter_table.sgml	2009-09-28 09:25:40.046261000 +0900
--- work/doc/src/sgml/ref/alter_table.sgml	2010-01-18 14:38:33.969376893 +0900
*************** ALTER TABLE <replaceable class="PARAMETE
*** 61,66 ****
--- 61,70 ----
      NO INHERIT <replaceable class="PARAMETER">parent_table</replaceable>
      OWNER TO <replaceable class="PARAMETER">new_owner</replaceable>
      SET TABLESPACE <replaceable class="PARAMETER">new_tablespace</replaceable>
+     PARTITION BY { RANGE | LIST } ( key ) [ <replaceable class="PARAMETER">opclass</replaceable> ] [ (...) ]
+     NO PARTITION
+     ATTACH PARTITION <replaceable class="PARAMETER">child_table</replaceable> VALUES ...
+     DETACH PARTITION <replaceable class="PARAMETER">child_table</replaceable>
  </synopsis>
   </refsynopsisdiv>
  
*************** ALTER TABLE <replaceable class="PARAMETE
*** 444,449 ****
--- 448,496 ----
      </listitem>
     </varlistentry>
  
+    <varlistentry>
+     <term><literal>PARTITION BY</literal></term>
+     <listitem>
+      <para>
+       This form adds a partition key and optional partitions to the table.
+       Inheritance and check constraints are internally added to the partitions.
+       See <xref linkend="sql-createtable"> for more information.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>NO PARTITION</literal></term>
+     <listitem>
+      <para>
+       This form removes the partition key from the table. If the table has
+       some partitions, partition values are also removed but inheritance and
+       check constraints are kept.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>ATTACH PARTITION</literal></term>
+     <listitem>
+      <para>
+       This form attaches an existing table as a partition with specified partition values.
+       Inheritance and check constraints are internally added to the partitions.
+       See <xref linkend="sql-createtable"> for more information.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>DETACH PARTITION</literal></term>
+     <listitem>
+      <para>
+       This form removes the specified partition the list of partitions of
+       the target table. The removed partition can be accessed as a normal table.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
    </variablelist>
    </para>
  
diff -cprN head/doc/src/sgml/ref/create_partition.sgml work/doc/src/sgml/ref/create_partition.sgml
*** head/doc/src/sgml/ref/create_partition.sgml	1970-01-01 09:00:00.000000000 +0900
--- work/doc/src/sgml/ref/create_partition.sgml	2010-01-18 14:38:33.970346337 +0900
***************
*** 0 ****
--- 1,164 ----
+ <refentry id="SQL-CREATEPARTITION">
+  <refmeta>
+   <refentrytitle id="sql-createtable-title">CREATE PARTITION</refentrytitle>
+   <manvolnum>7</manvolnum>
+   <refmiscinfo>SQL - Language Statements</refmiscinfo>
+  </refmeta>
+ 
+  <refnamediv>
+   <refname>CREATE PARTITION</refname>
+   <refpurpose>define a new table</refpurpose>
+  </refnamediv>
+ 
+  <indexterm zone="sql-createpartition">
+   <primary>CREATE PARTITION</primary>
+  </indexterm>
+ 
+  <refsynopsisdiv>
+ <synopsis>
+ CREATE PARTITION <replaceable class="PARAMETER">partition_name</replaceable>
+   ON <replaceable class="PARAMETER">table_name</replaceable>
+   {
+       VALUES LESS THAN { <replaceable class="PARAMETER">value</replaceable> | MAXVALUE }
+     | VALUES [ IN ] [ ( ] { <replaceable class="PARAMETER">value</replaceable> [, ...] | DEFAULT } [ ) ]
+   }
+ [ WITH ( <replaceable class="PARAMETER">storage_parameter</replaceable> [= <replaceable class="PARAMETER">value</replaceable>] [, ... ] ) | WITH OIDS | WITHOUT OIDS ]
+ [ TABLESPACE <replaceable class="PARAMETER">tablespace</replaceable> ]
+ </synopsis>
+ 
+  </refsynopsisdiv>
+ 
+  <refsect1 id="SQL-CREATEPARTITION-description">
+   <title>Description</title>
+ 
+   <para>
+    <command>CREATE PARTITION</command> will create a new, initially empty
+    partition which has the same definitions with the parent table, and add
+    it as a partition to the parent table. The parent table must be
+    partitioned before the command. The partition will be owned by the user
+    issuing the command.
+   </para>
+ 
+   <para>
+    If a schema name is given (for example, <literal>CREATE PARTITION
+    myschema.mypartition ...</>) then the partition is created in the
+    specified schema.  Otherwise it is created in the same schema with
+    the parent. The name of the partition  must be distinct from the
+    name of any other partitions, table, sequence, index, or view
+    in the same schema.
+   </para>
+ 
+   <para>
+    <command>CREATE PARTITION</command> is a syntactic sugar for
+    <command>CREATE TABLE partition_name (LIKE parent_table)</command> and
+    <command>ALTER TABLE parent_table ATTACH PARTITION partition_name</command>
+    See <xref linkend="sql-createtable"> and  <xref linkend="sql-altertable">
+    for more information.
+   </para>
+  </refsect1>
+ 
+  <refsect1>
+   <title>Parameters</title>
+ 
+   <variablelist>
+ 
+    <varlistentry>
+     <term><replaceable class="PARAMETER">partition_name</replaceable></term>
+     <listitem>
+      <para>
+       The name (optionally schema-qualified) of the table to be created.
+       If schema is not specified, use the same schema with the parent table.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><replaceable class="PARAMETER">table_name</replaceable></term>
+     <listitem>
+      <para>
+       The name (optionally schema-qualified) of the parent table.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>WITH ( <replaceable class="PARAMETER">storage_parameter</replaceable> [= <replaceable class="PARAMETER">value</replaceable>] [, ... ] )</literal></term>
+     <listitem>
+      <para>
+       This clause specifies optional storage parameters for a table or index;
+       see <xref linkend="sql-createtable-storage-parameters"
+       endterm="sql-createtable-storage-parameters-title"> for more
+       information.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>TABLESPACE <replaceable class="PARAMETER">tablespace</replaceable></literal></term>
+     <listitem>
+      <para>
+       The <replaceable class="PARAMETER">tablespace</replaceable> is the name
+       of the tablespace in which the new table is to be created.
+       If not specified,
+       <xref linkend="guc-default-tablespace"> is consulted, or
+       <xref linkend="guc-temp-tablespaces"> if the table is temporary.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+   </variablelist>
+ 
+  </refsect1>
+ 
+  <refsect1 id="SQL-CREATEPARTITION-examples">
+   <title>Examples</title>
+ 
+   <para>
+    Create partitions for each year on parent table <structname>sales</>:
+ 
+ <programlisting>
+ CREATE TABLE sales (
+     salesman_id       integer PRIMARY KEY,
+     salesman_name     varchar(30),
+     sales_state       varchar(20),
+     sales_date        timestamp
+ )
+ PARTITION BY RANGE (sales_date);
+ 
+ CREATE PARTITION sales_2008 ON sales VALUES LESS THAN ('2009-01-01');
+ CREATE PARTITION sales_2009 ON sales VALUES LESS THAN ('2010-01-01');
+ CREATE PARTITION sales_2010 ON sales VALUES LESS THAN ('2011-01-01');
+ </programlisting>
+ 
+   </para>
+ 
+   <para>
+    Create a table with a 2-dimensional array:
+ 
+ <programlisting>
+ CREATE TABLE array_int (
+     vector  int[][]
+ );
+ </programlisting>
+   </para>
+ 
+  </refsect1>
+ 
+  <refsect1>
+   <title>Compatibility</title>
+ 
+   <para>
+    There is no <command>CREATE PARTITION</command> statement in the SQL standard.
+   </para>
+  </refsect1>
+ 
+  <refsect1>
+   <title>See Also</title>
+ 
+   <simplelist type="inline">
+    <member><xref linkend="sql-altertable" endterm="sql-altertable-title"></member>
+    <member><xref linkend="sql-droptable" endterm="sql-droptable-title"></member>
+    <member><xref linkend="sql-createtablespace" endterm="sql-createtablespace-title"></member>
+   </simplelist>
+  </refsect1>
+ </refentry>
diff -cprN head/doc/src/sgml/ref/create_table.sgml work/doc/src/sgml/ref/create_table.sgml
*** head/doc/src/sgml/ref/create_table.sgml	2009-12-09 13:45:22.745455000 +0900
--- work/doc/src/sgml/ref/create_table.sgml	2010-01-18 14:38:33.970346337 +0900
*************** CREATE [ [ GLOBAL | LOCAL ] { TEMPORARY 
*** 31,36 ****
--- 31,42 ----
  [ WITH ( <replaceable class="PARAMETER">storage_parameter</replaceable> [= <replaceable class="PARAMETER">value</replaceable>] [, ... ] ) | WITH OIDS | WITHOUT OIDS ]
  [ ON COMMIT { PRESERVE ROWS | DELETE ROWS | DROP } ]
  [ TABLESPACE <replaceable class="PARAMETER">tablespace</replaceable> ]
+ [ PARTITION BY { RANGE | LIST } ( key ) [ <replaceable class="PARAMETER">opclass</replaceable> ]
+   [ ( {
+         PARTITION <replaceable class="PARAMETER">partition</replaceable> VALUES LESS THAN { <replaceable class="PARAMETER">value</replaceable> | MAXVALUE }
+       | PARTITION <replaceable class="PARAMETER">partition</replaceable> VALUES [ IN ] [ ( ] { <replaceable class="PARAMETER">value</replaceable> [, ...] | DEFAULT } [ ) ]
+   } ) ]
+ ]
  
  <phrase>where <replaceable class="PARAMETER">column_constraint</replaceable> is:</phrase>
  
*************** CREATE [ [ GLOBAL | LOCAL ] { TEMPORARY 
*** 762,767 ****
--- 768,784 ----
      </listitem>
     </varlistentry>
  
+    <varlistentry>
+     <term><literal>PARTITION BY</literal></term>
+     <listitem>
+      <para>
+       This clause adds a <literal>RANGE</literal> or <literal>LIST</literal>
+       partition key and optional partitions into the table.
+       When a named partition exist as a table, it inherits this table.
+       If not exists, a new table is automatically created and used.
+      </para>
+     </listitem>
+    </varlistentry>
    </variablelist>
  
    <refsect2 id="SQL-CREATETABLE-storage-parameters">
*************** CREATE TABLE cinemas (
*** 1182,1187 ****
--- 1199,1224 ----
  </programlisting>
    </para>
  
+   <para>
+    Create a table <literal>films</literal> with partitions for each
+    released year:
+ 
+ <programlisting>
+ CREATE TABLE films (
+     code        char(5) PRIMARY KEY,
+     title       varchar(40),
+     released    date,
+     kind        varchar(10),
+     len         interval hour to minute
+ )
+ PARTITION BY RANGE (released)
+ (
+     PARTITION films_2008 VALUES LESS THAN ('2009-01-01'),
+     PARTITION films_2009 VALUES LESS THAN ('2010-01-01'),
+     PARTITION films_2010 VALUES LESS THAN ('2011-01-01')
+ );
+ </programlisting>
+   </para>
   </refsect1>
  
   <refsect1 id="SQL-CREATETABLE-compatibility">
diff -cprN head/src/backend/catalog/Makefile work/src/backend/catalog/Makefile
*** head/src/backend/catalog/Makefile	2010-01-07 09:24:42.729068000 +0900
--- work/src/backend/catalog/Makefile	2010-01-18 14:38:33.971469780 +0900
*************** POSTGRES_BKI_SRCS = $(addprefix $(top_sr
*** 37,43 ****
  	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
  	pg_ts_parser.h pg_ts_template.h \
  	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
! 	pg_default_acl.h \
  	toasting.h indexing.h \
      )
  
--- 37,43 ----
  	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
  	pg_ts_parser.h pg_ts_template.h \
  	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
! 	pg_default_acl.h pg_partition.h \
  	toasting.h indexing.h \
      )
  
